<template>
  <div>
    <div v-show="status === Status.LOADING">
      <content-loader-table
        :height="350"
        :num-rows="5"
      />
    </div>
    <div v-show="status === Status.SUCCESS">
      <b-table
        :current-page="currentPage"
        :fields="fields"
        :items="watchListObjects"
        :per-page="perPage"
        :sort-by.sync="sortBy"
        :sort-desc.sync="sortDesc"
        bordered
        small
        striped
      />
      <!-- This <b-row>...</b-row> block builds the pagination function for the table. -->
      <b-row align-h="between">
        <b-col>
          <b-row>
            <b-col>
              <b-form inline>
                <label class="mr-2">Show</label>
                <b-form-select
                  v-model="perPage"
                  :options="pageOptions"
                  class="mr-2"
                />
                <label class="mr-1">entries</label>
              </b-form>
            </b-col>
          </b-row>
          <b-row>
            <b-col>
              <p class="font-weight-lighter">
                Showing {{ pageStart }} to {{ pageEnd }} of {{ rows }} entries
              </p>
            </b-col>
          </b-row>
        </b-col>
        <b-col>
          <b-pagination
            v-model="currentPage"
            :per-page="perPage"
            :total-rows="rows"
            align="right"
          />
        </b-col>
      </b-row>
    </div>
    <div v-show="status === Status.ERROR">
      <b-list-group>
        <b-list-group-item variant="danger">
          <h5>Error Loading Catalogs</h5>
          <p>There was an error loading watch list objects.</p>
          <pre>{{ JSON.stringify(errorMessage, null, 2) }}</pre>
        </b-list-group-item>
      </b-list-group>
    </div>
  </div>
</template>

<script lang="ts">
import Vue from 'vue';
import { WatchListService } from '@/api';
import { WatchObject } from '@/common/types';
import ContentLoaderTable from '@/components/ContentLoaderTable.vue';

/* eslint-disable-next-line no-shadow */
enum Status {
  LOADING = 'LOADING',
  ERROR = 'ERROR',
  SUCCESS = 'SUCCESS',
}

export default Vue.extend({
  components: {
    ContentLoaderTable,
  },

  props: {
    watchListId: {
      type: String,
      required: true,
    },
  },

  data() {
    return {
      Status,
      count: 0,
      currentPage: 1,
      errorMessage: '',
      fields: [
        {
          key: 'right_ascension',
          label: 'Right Ascension',
          sortable: true,
        },
        {
          key: 'declination',
          label: 'Declination',
          sortable: true,
        },
        {
          key: 'radius',
          label: 'Radius',
          sortable: true,
        },
        {
          key: 'comment',
          label: 'Comment',
          sortable: true,
        },
      ],
      loading: false,
      sortBy: 'created_at',
      sortDesc: true,
      status: Status.LOADING,
      pageOptions: [5, 10, 25, 50, 100],
      perPage: 5,
      watchListObjects: [] as WatchObject[],
    };
  },

  computed: {
    pageEnd(): number {
      const pageEnd = this.pageStart + this.perPage - 1;
      return pageEnd > this.rows ? this.rows : pageEnd;
    },
    pageStart(): number {
      return (this.currentPage - 1) * this.perPage + 1;
    },
    rows(): number {
      return this.count;
    },
  },

  mounted() {
    this.fetchWatchListObjects();
  },

  methods: {
    async fetchWatchListObjects() {
      this.status = Status.LOADING;
      try {
        const { data: watchList } = await WatchListService.get(this.watchListId);
        this.count = watchList.objects.length;
        this.status = Status.SUCCESS;
        this.watchListObjects = watchList.objects;
      } catch (error) {
        /* eslint-disable-next-line prefer-destructuring */
        this.errorMessage = error[0];
        this.status = Status.ERROR;
      }
    },
  },
});
</script>

<style scoped></style>
